//   - --- -   
//    -  5 
// (c) Proteus 2006 (icq 133575351)

//         
//       ,      
//       ,     
//     ss,       
//     ss   -       -  
//    ,    .
//
//         :
// sl=ss[0]&ss[2]; - ..      0  2 
//   - ..       
//
//  :
// sl=ss[0]&ss[2];      -  5 
// sl=ss[0]&ss[1]&ss[2] - 7
// sl=ss[1]&ss[3]       - 10
//
//    :
// nx1=ss[0]&mask[sym]&~sl;   ss[0]=mask[sym];
// nx2=ss[1]&nx1; ss[1]=(ss[1]^nx1)&mask[sym];
// nx1=ss[2]&nx2; ss[2]=(ss[2]^nx2)&mask[sym];
// nx2=ss[3]&nx1; ss[3]=(ss[3]^nx1)&mask[sym];
//                ss[4]=(ss[4]^nx2)&mask[sym];


#include<stdio.h>
#include<string.h>

typedef unsigned char BYTE;
typedef unsigned long DWORD;

DWORD mask[256]; //    (      ,        )

char text[]="1haxxxaa8asdhajhdjhg12x4x6x8dfaskjdhajhd123x5678QAJSDWAjdkejfdfhsjkdfhsjkdfhs12345678djshdfk";
char pattern[]="12345678";

#define BITS 32


void Work()
{
	int n,m; BYTE sym; DWORD bit=1; DWORD nx1,nx2; 
	DWORD s;     //  
	DWORD sl;    //       
	DWORD ss[3]; // 
	if(strlen(pattern)>BITS) {printf("too big pattern\n\a");return;}
	for(n=0; n<256; n++) mask[n]=0; bit=1<<strlen(pattern); s=0;
	for(n=0; n<strlen(pattern); n++) {	//  
		bit=bit>>1;
		mask[(BYTE)pattern[n]]|=bit; 
		s|=bit;
	}
	for(n=0; n<256; n++) mask[n]=s&~mask[n]; //  
	ss[0]=ss[1]=ss[2]=0;
	for(n=0; n<strlen(text); n++) {
		sym=text[n];
		s=s>>1; sl=sl>>1;
		ss[0]=ss[0]>>1;
		ss[1]=ss[1]>>1;
		ss[2]=ss[2]>>1;
		nx1=ss[0]&mask[sym]&~sl; ss[0]=mask[sym];
		nx2=ss[1]&nx1; ss[1]=(ss[1]^nx1)&mask[sym];
		ss[2]=(ss[2]^nx2)&mask[sym];
		sl=ss[0]&ss[2];
		s|=sl;
		if(!(s&1)) { 
			n-=strlen(pattern)-1;
			printf("pos: %d\n",n);
			printf("%s=",pattern); for(m=0; m<strlen(pattern); m++) putchar(text[n+m]); printf(" ..\n");
			return;
		}
	}
	printf("not found\n\a");
}


void main()
{
	Work();
}

